#include <iostream>
#include <cstdio>
#include <map>
#include <string>
#include <cstring>
#include <cstdlib>
#include <algorithm>

using namespace std;

typedef long double real;

enum {M=222};

real mat[M][M];

map<string, int> m;
string mr[M];
int c,r;

int main()
{
    while(cin >> c, c) {
        for(int i=0; i<c; ++i) {
            cin >> mr[i];
            m[mr[i]] = i;
        }

        for(int i=0; i<c; ++i){
            for(int j=0; j<c; ++j)
                mat[i][j] = 0;
        }

        for(int i=0; i<c; ++i)
            mat[i][i]=1;

        cin >> r;
        for(int i=0; i<r; ++i) {
            string a,b;
            char x[20];
            cin >> a >> b >> x;
            char *j = strchr(x, ':');
            *j = 0; ++j;
            real rate = strtold(j, NULL) / strtold(x, NULL);
//            cout << "AAAA " << rate << endl;
            mat[m[a]][m[b]] = rate;
        }

        for(int i=0; i<c; ++i) {
            for(int j=0; j<c; ++j) {
                for(int k=0; k<c; ++k) {
                    mat[j][k] = max(mat[j][k], mat[j][i]*mat[i][k]);
                }
            }
        }

        bool ok = true;
        for(int i=0; i<c; ++i) {
            if(mat[i][i] > 1)
                ok = false;
        }
        cout << (ok?"Ok":"Arbitrage") << endl;
    }
    return 0;
}
